------------------------------------------------------------
IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_CacheOptions')
BEGIN
CREATE TABLE [dbo].[ut_CacheOptions]
(
   [RecId]  integer NOT NULL
  ,[MandId] integer DEFAULT 1
  ,[TableAlias] char(30) DEFAULT ' '
  ,[LevelSql] integer DEFAULT 0
  ,[LevelTLDBS] integer DEFAULT 0
  ,[LevelCodebase] integer DEFAULT 0
  CONSTRAINT [Pk_CacheOptions]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_CacheOptions_KeyDel')
  DROP TRIGGER [dbo].[tr_CacheOptions_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_CacheOptions_KeyUpd')
  DROP TRIGGER [dbo].[tr_CacheOptions_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_CacheOptions_Keys')
  DROP TABLE [dbo].[ut_CacheOptions_Keys]
GO

IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_CacheOptions' and sc.[name] = 'TableAlias')
BEGIN
  ALTER TABLE [dbo].[ut_CacheOptions] ADD [TableAlias] char(30) NOT NULL DEFAULT ' '
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_CacheOptions' and sc.[name] = 'LevelSql')
BEGIN
  ALTER TABLE [dbo].[ut_CacheOptions] ADD [LevelSql] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_CacheOptions' and sc.[name] = 'LevelTLDBS')
BEGIN
  ALTER TABLE [dbo].[ut_CacheOptions] ADD [LevelTLDBS] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_CacheOptions' and sc.[name] = 'LevelCodebase')
BEGIN
  ALTER TABLE [dbo].[ut_CacheOptions] ADD [LevelCodebase] integer NOT NULL DEFAULT 0
END
GO
IF 30 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_CacheOptions' and sc.[name] = 'TableAlias')
BEGIN
  ALTER TABLE [dbo].[ut_CacheOptions] ALTER COLUMN [TableAlias] char(30)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'CacheOptions')
  DROP VIEW [dbo].[CacheOptions]
GO
CREATE VIEW [dbo].[CacheOptions] AS
  SELECT * FROM [dbo].[ut_CacheOptions]
GO
CREATE TABLE [dbo].[ut_CacheOptions_Keys]
(
   [DataRecId]  integer NOT NULL
  ,[DataMandId] integer DEFAULT 1
  ,[Key00_Value] CHAR(40) NOT NULL
  CONSTRAINT [Pk_ut_CacheOptions_Keys]  PRIMARY KEY NONCLUSTERED ( [DataRecId] )
)
GO
CREATE TRIGGER [dbo].[tr_CacheOptions_KeyDel] ON [dbo].[ut_CacheOptions]
FOR DELETE
AS
  SET NOCOUNT ON
  DELETE FROM [dbo].[ut_CacheOptions_Keys] WITH (SERIALIZABLE)
  WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)
GO

CREATE TRIGGER [dbo].[tr_CacheOptions_KeyUpd] ON [dbo].[ut_CacheOptions]
FOR INSERT, UPDATE
AS
  SET NOCOUNT ON
  IF UPDATE([RecId]) OR UPDATE([MandId])
  BEGIN
    DELETE FROM [dbo].[ut_CacheOptions_Keys] WITH (SERIALIZABLE)
    WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)

    INSERT INTO [dbo].[ut_CacheOptions_Keys] WITH (SERIALIZABLE)
    ([DataRecId],[DataMandId],[Key00_Value])
    (SELECT [RecId],[MandId]
     ,UPPER(convert(char(30),[TableAlias])+STR(RecId,10))

    FROM INSERTED)
  END
  ELSE
  BEGIN
    UPDATE [dbo].[ut_CacheOptions_Keys] WITH (SERIALIZABLE) SET
    [Key00_Value] = UPPER(convert(char(30),[TableAlias])+STR([RecId],10))
    FROM INSERTED WHERE [DataRecId] = [RecId]
  END
GO

UPDATE [dbo].[ut_CacheOptions] SET RecId = RecId
GO


------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_CacheOptions')
  DROP PROCEDURE [dbo].[up_Add_CacheOptions]
GO
CREATE PROCEDURE [dbo].[up_Add_CacheOptions] AS
  DECLARE @NeueId integer
  SET @NeueId = (SELECT MAX(RecId) from [dbo].[ut_CacheOptions])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_CacheOptions] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_CacheOptions')
  DROP PROCEDURE [dbo].[up_Upd_CacheOptions]
GO
CREATE PROCEDURE [dbo].[up_Upd_CacheOptions]
  @RI integer
 ,@Parm_TableAlias char(30)
 ,@Parm_LevelSql integer
 ,@Parm_LevelTLDBS integer
 ,@Parm_LevelCodebase integer
AS
--BEGIN TRANSACTION
UPDATE [dbo].[ut_CacheOptions] SET
     [TableAlias] = RTRIM(@Parm_TableAlias)
    ,[LevelSql] = @Parm_LevelSql
    ,[LevelTLDBS] = @Parm_LevelTLDBS
    ,[LevelCodebase] = @Parm_LevelCodebase
  WHERE RecId = @RI
--COMMIT TRANSACTION
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_CacheOptions')
  DROP PROCEDURE [dbo].[up_Sel_CacheOptions]
GO
CREATE PROCEDURE [dbo].[up_Sel_CacheOptions]
  @RI integer
AS
SELECT
     [TableAlias]
    ,[LevelSql]
    ,[LevelTLDBS]
    ,[LevelCodebase]
  FROM [dbo].[ut_CacheOptions]
  WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_CacheOptions')
  DROP PROCEDURE [dbo].[up_Del_CacheOptions]
GO
CREATE PROCEDURE [dbo].[up_Del_CacheOptions]
  @RI integer
AS
  DELETE FROM [dbo].[ut_CacheOptions] WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_CacheOptions')
  DROP PROCEDURE [dbo].[up_Reorg_CacheOptions]
GO
CREATE PROCEDURE [dbo].[up_Reorg_CacheOptions]
  @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_CacheOptions] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_CacheOptions] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_CacheOptions] )
  END

GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_CacheOptions')
  DROP PROCEDURE [dbo].[up_Append_CacheOptions]
GO
CREATE PROCEDURE [dbo].[up_Append_CacheOptions]
  @Parm_TableAlias char(30)
 ,@Parm_LevelSql integer
 ,@Parm_LevelTLDBS integer
 ,@Parm_LevelCodebase integer
AS
  DECLARE @NeueId    integer
  SET     @NeueId = (SELECT MAX(RecId) FROM [dbo].[ut_CacheOptions])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_CacheOptions] (
    RecId
   ,[TableAlias]
   ,[LevelSql]
   ,[LevelTLDBS]
   ,[LevelCodebase]
     ) VALUES (
    @NeueId
   ,RTRIM(@Parm_TableAlias)
   ,@Parm_LevelSql
   ,@Parm_LevelTLDBS
   ,@Parm_LevelCodebase
       )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_CacheOptions')
  DROP PROCEDURE [dbo].[up_TrSel_CacheOptions]
GO
CREATE PROCEDURE [dbo].[up_TrSel_CacheOptions]
AS
  SELECT   RecId,
      LTRIM(RTRIM([TableAlias]))
    AS Data
  FROM     [dbo].[ut_CacheOptions]
  WHERE    RecId > 0
  ORDER BY RecId
GO

CREATE INDEX [Ik_Key00] ON [dbo].[ut_CacheOptions_Keys]
( [Key00_Value],[DataRecId] )
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_First_CacheOptions_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_Last_CacheOptions_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_Prior_CacheOptions_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_Next_CacheOptions_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_Prior50_CacheOptions_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_Next50_CacheOptions_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_FindL_CacheOptions_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_CacheOptions_Key00')
  DROP PROCEDURE [dbo].[up_FindF_CacheOptions_Key00]
GO

CREATE PROCEDURE [dbo].[up_First_CacheOptions_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_CacheOptions_Keys] ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Last_CacheOptions_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_CacheOptions_Keys] ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next_CacheOptions_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_CacheOptions_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_CacheOptions_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior_CacheOptions_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_CacheOptions_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_CacheOptions_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next50_CacheOptions_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_CacheOptions_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_CacheOptions_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior50_CacheOptions_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_CacheOptions_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_CacheOptions_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_FindF_CacheOptions_Key00] @xKey char(128),@xLen integer
AS
  SELECT a.[DataRecId] FROM
    ( SELECT TOP 1 [DataRecId],[Key00_Value] AS Key_Value FROM [dbo].[ut_CacheOptions_Keys]
      WHERE [Key00_Value] >= SUBSTRING(@xKey,1,@xLen)
      ORDER BY [Key00_Value]
    ) a
  WHERE a.Key_Value like SUBSTRING(@xKey,1,@xLen)+'%'
GO

CREATE PROCEDURE [dbo].[up_FindL_CacheOptions_Key00] @xKey char(128),@xLen integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_CacheOptions_Keys]
  WHERE [Key00_Value] like SUBSTRING(@xKey,1,@xLen)+'%'
  ORDER BY [Key00_Value] DESC
GO

